image: ubuntu

before_script:
  - apt-get update
  - apt-get install splint build-essential python3 -y
  
stages:
  - pr1
  - pr2
  - pr3
  - pr4
  - pr5
  - pr6
  - pr7
  
# Первая практическая работа

pr1_hello_splint:
  stage: pr1
  only:
    changes:
    - pr1/*.c
  script:
  - splint pr1/01_*.c
  allow_failure: true

pr1_hello_test:
  stage: pr1
  only:
    changes:
    - pr1/*.c
  script:
  - gcc pr1/01_*.c
  - python3 pr1/tests/01_hello_world.py

pr1_sum_splint:
  stage: pr1
  only:
    changes:
    - pr1/*.c
  script:
  - splint pr1/02_*.c
  allow_failure: true

pr1_sum_test:
  stage: pr1
  only:
    changes:
    - pr1/*.c
  script:
  - gcc pr1/02_*.c
  - python3 pr1/tests/02_sum.py

pr1_pow_splint:
  stage: pr1
  only:
    changes:
    - pr1/*.c
  script:
  - splint pr1/03_*.c
  allow_failure: true

pr1_pow_test:
  stage: pr1
  only:
    changes:
    - pr1/*.c
  script:
  - gcc pr1/03_*.c -lm
  - python3 pr1/tests/03_pow.py

# Вторая практическая работа

pr2_task03_splint:
  stage: pr2
  only:
    changes:
    - pr2/*.c
  script:
  - splint pr2/03_*.c
  allow_failure: true

pr2_task03_tests:
  stage: pr2
  only:
    changes:
    - pr2/*.c
  script:
  - gcc pr2/03_*.c -lm
  - python3 pr2/tests/checker.py 03

pr2_task13_splint:
  stage: pr2
  only:
    changes:
    - pr2/*.c
  script:
  - splint pr2/13_*.c
  allow_failure: true

pr2_task13_tests:
  stage: pr2
  only:
    changes:
    - pr2/*.c
  script:
  - gcc pr2/13_*.c -lm
  - python3 pr2/tests/checker.py 13
  
  # Третья практическая работа

pr3_easy_test:
  stage: pr3
  only:
    changes:
    - pr3/*.c
  script:
  - gcc pr3/01_*.c
  - python3 pr3/tests/checker.py 0

pr3_middle_test:
  stage: pr3
  only:
    changes:
    - pr3/*.c
  script:
  - gcc pr3/01_*.c
  - python3 pr3/tests/checker.py 1
  allow_failure: true

pr3_hard_test:
  stage: pr3
  only:
    changes:
    - pr3/*.c
  script:
  - gcc pr3/01_*.c
  - python3 pr3/tests/checker.py 2
  allow_failure: true

# Четвертая практическая работа

pr4_easy_test:
  stage: pr4
  only:
    changes:
    - pr4/*.c
  script:
  - gcc pr4/01_*.c
  - python3 pr4/tests/checker.py 0

pr4_middle_test:
  stage: pr4
  only:
    changes:
    - pr4/*.c
  script:
  - gcc pr4/01_*.c
  - python3 pr4/tests/checker.py 1
  allow_failure: true

pr4_hard_test:
  stage: pr4
  only:
    changes:
    - pr4/*.c
  script:
  - gcc pr4/01_*.c
  - python3 pr4/tests/checker.py 2
  allow_failure: true

# Пятая практическая работа

pr5_easy_test:
  stage: pr5
  only:
    changes:
    - pr5/*.c
  script:
  - gcc pr5/01_*.c
  - PYTHONIOENCODING=utf-8 python3 pr5/tests/checker.py 0

pr5_middle_test:
  stage: pr5
  only:
    changes:
    - pr5/*.c
  script:
  - gcc pr5/01_*.c
  - PYTHONIOENCODING=utf-8 python3 pr5/tests/checker.py 1
  allow_failure: true

# Шестая практическая работа

pr6_01_test:
  stage: pr6
  only:
    changes:
    - pr6/*.c
  script:
  - gcc pr6/01_*.c
  - python3 pr6/tests/checker.py 0

pr6_02_test:
  stage: pr6
  only:
    changes:
    - pr6/*.c
  script:
  - gcc pr6/02_*.c
  - python3 pr6/tests/checker.py 1

pr6_03_test:
  stage: pr6
  only:
    changes:
    - pr6/*.c
  script:
  - gcc pr6/03_*.c
  - python3 pr6/tests/checker.py 2

# Седьмая практическая работа

# pr7_general_test:
#   stage: pr7
#   script:
#   - gcc pr7/*.c
#   - python3 pr7/tests/checker.py 0

# pr7_quicksort_test:
#   stage: pr7
#   script:
#   - gcc pr7/*.c
#   - python3 pr7/tests/checker.py 1

# pr7_heapsort_test:
#   stage: pr7
#   script:
#   - gcc pr7/*.c
#   - python3 pr7/tests/checker.py 2
